package de.fhdw.wtf.generator.database.exception;

/**
 * This exception is thrown when 2 associations dont have the same attribute or when one type is not a super type of a
 * other type.
 */
public class NotSameAttributeException extends GenerationException {
	
	/**
	 * message of the exception.
	 */
	private static final String NOT_SAME_NAME_MESSAGE =
			"Prerequisite error: All elements must have the same attribute: ";
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	/**
	 * This exception is thrown when 2 associations dont have the same attribute or when one type is not a super type of
	 * a other type.
	 * 
	 * @param attributeName
	 *            name of the attribute
	 */
	public NotSameAttributeException(final String attributeName) {
		super(NOT_SAME_NAME_MESSAGE + attributeName);
	}
}
