package de.fhdw.wtf.generator.transformer.transformers.classTransformer;

import java.util.Vector;

import de.fhdw.wtf.common.ast.Model;
import de.fhdw.wtf.common.ast.type.Type;
import de.fhdw.wtf.common.exception.walker.TaskException;
import de.fhdw.wtf.common.task.TaskExecutor;
import de.fhdw.wtf.generator.java.generatorModel.GenComment;
import de.fhdw.wtf.generator.java.generatorModel.GenException;
import de.fhdw.wtf.generator.java.generatorModel.GenJavaOperation;
import de.fhdw.wtf.generator.java.generatorModel.GenOperationModifier;
import de.fhdw.wtf.generator.java.generatorModel.GenParameter;
import de.fhdw.wtf.generator.java.generatorModel.GenTypeReferenceByName;
import de.fhdw.wtf.generator.java.generatorModel.GenVisibility;
import de.fhdw.wtf.walker.walker.SimpleWalkerTaskForTypes;

public class CreateSetterForSymmetricAttributeTransformer extends SimpleWalkerTaskForTypes {
	
	public CreateSetterForSymmetricAttributeTransformer(final Model m, final TaskExecutor taskmanager) {
		super(m, taskmanager);
		// TODO Auto-generated constructor stub
	}
	
	/**
	 * removes in the given class his symmetrical partner.
	 * 
	 * @param name
	 * @return
	 */
	private GenJavaOperation createRemove(final String name) {
		final Vector<GenOperationModifier> getInstanceModifiers = new Vector<>();
		getInstanceModifiers.add(GenOperationModifier.STATIC);
		
		final Vector<GenParameter> genParameterVector = new Vector<>();
		final GenParameter genParameter = GenParameter.create("symmetricalOther", GenTypeReferenceByName.create(name));
		genParameterVector.add(genParameter);
		
		final GenJavaOperation result =
				GenJavaOperation.create(
						"remove" + name,
						GenVisibility.PRIVATE,
						genParameterVector,
						new Vector<GenException>(),
						"TODO not implemented yet.", // TODO muss noch implementiert werden
						null,
						getInstanceModifiers,
						GenComment.create("TODO"));
		return result;
		
	}
	
	/**
	 * creates in the given class a set-method, that sets the symmetrical relationship.
	 * 
	 * @param name
	 *            name of the symmetrical other class
	 * @return a GenJavaOperation, a set-method.
	 */
	// private Attribute createSet() {
	// final String name;
	// final Vector<GenOperationModifier> getInstanceModifiers = new Vector<>();
	// getInstanceModifiers.add(GenOperationModifier.STATIC);
	//
	// final Vector<GenParameter> genParameterVector = new Vector<>();
	// final GenParameter genParameter = GenParameter.create("symmetricalOther", GenTypeReferenceByName.create(name));
	// genParameterVector.add(genParameter);
	//
	// final GenJavaOperation result =
	// GenJavaOperation.create(
	// "set" + name,
	// GenVisibility.PRIVATE,
	// genParameterVector,
	// new Vector<GenException>(),
	// "this." + name + "=symmetricalOther;", // TODO J geht noch weiter
	// null,
	// getInstanceModifiers,
	// GenComment.create("This is the private set of the symmetricalOther parameter."));
	// return result;
	//
	// }
	
	/**
	 * creates the 'set'-methods in a class for each symmetric parameter.
	 */
	// private void createSet(final String s, final GenType g) {
	// final GenType symmetricRelationAccessClass = null;
	// final Vector<GenParameter> genParameterVector = new Vector<>();
	// final GenParameter genParameter = GenParameter.create("symmetricalOther", g);
	// genParameterVector.add(genParameter);
	// final GenJavaOperation setOperation =
	// GenJavaOperation.create(
	// "set" + s,
	// GenVisibility.PRIVATE,
	// genParameterVector,
	// new Vector<GenException>(),
	// "this." + s + "=symmetricalOther;", // TODO geht noch weiter
	// symmetricRelationAccessClass,
	// new Vector<GenOperationModifier>(),
	// GenComment.create(""));
	// cc.addOperation(setOperation);
	// }
	
	// @Override
	@Override
	public void handleType(final Type c) throws TaskException {
		// if (c instanceof ClassType) {
		// final Collection<Attribute> attributes = ((ClassType) c).getAttributes();
		// final Iterator<Attribute> i = attributes.iterator();
		// while (i.hasNext()) {
		// final Attribute current = i.next();
		// if (current.isSymmetric()) {
		// this.createSet(current.getName(), c);}
		// }
		// }
		//
		// }
	}
	
	@Override
	public void beginTask() throws TaskException {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void finalizeTask() throws TaskException {
		// TODO Auto-generated method stub
		
	}
}
